// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from robot_calibration_msgs:msg/CaptureConfig.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__TRAITS_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "robot_calibration_msgs/msg/detail/capture_config__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'joint_states'
#include "sensor_msgs/msg/detail/joint_state__traits.hpp"

namespace robot_calibration_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CaptureConfig & msg,
  std::ostream & out)
{
  out << "{";
  // member: joint_states
  {
    out << "joint_states: ";
    to_flow_style_yaml(msg.joint_states, out);
    out << ", ";
  }

  // member: features
  {
    if (msg.features.size() == 0) {
      out << "features: []";
    } else {
      out << "features: [";
      size_t pending_items = msg.features.size();
      for (auto item : msg.features) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CaptureConfig & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: joint_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "joint_states:\n";
    to_block_style_yaml(msg.joint_states, out, indentation + 2);
  }

  // member: features
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.features.size() == 0) {
      out << "features: []\n";
    } else {
      out << "features:\n";
      for (auto item : msg.features) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CaptureConfig & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace robot_calibration_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_calibration_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_calibration_msgs::msg::CaptureConfig & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_calibration_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_calibration_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const robot_calibration_msgs::msg::CaptureConfig & msg)
{
  return robot_calibration_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<robot_calibration_msgs::msg::CaptureConfig>()
{
  return "robot_calibration_msgs::msg::CaptureConfig";
}

template<>
inline const char * name<robot_calibration_msgs::msg::CaptureConfig>()
{
  return "robot_calibration_msgs/msg/CaptureConfig";
}

template<>
struct has_fixed_size<robot_calibration_msgs::msg::CaptureConfig>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<robot_calibration_msgs::msg::CaptureConfig>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<robot_calibration_msgs::msg::CaptureConfig>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__TRAITS_HPP_
