// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from robot_calibration_msgs:msg/CameraParameter.idl
// generated code does not contain a copyright notice
#include "robot_calibration_msgs/msg/detail/camera_parameter__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"

bool
robot_calibration_msgs__msg__CameraParameter__init(robot_calibration_msgs__msg__CameraParameter * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    robot_calibration_msgs__msg__CameraParameter__fini(msg);
    return false;
  }
  // value
  return true;
}

void
robot_calibration_msgs__msg__CameraParameter__fini(robot_calibration_msgs__msg__CameraParameter * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // value
}

bool
robot_calibration_msgs__msg__CameraParameter__are_equal(const robot_calibration_msgs__msg__CameraParameter * lhs, const robot_calibration_msgs__msg__CameraParameter * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // value
  if (lhs->value != rhs->value) {
    return false;
  }
  return true;
}

bool
robot_calibration_msgs__msg__CameraParameter__copy(
  const robot_calibration_msgs__msg__CameraParameter * input,
  robot_calibration_msgs__msg__CameraParameter * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // value
  output->value = input->value;
  return true;
}

robot_calibration_msgs__msg__CameraParameter *
robot_calibration_msgs__msg__CameraParameter__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__CameraParameter * msg = (robot_calibration_msgs__msg__CameraParameter *)allocator.allocate(sizeof(robot_calibration_msgs__msg__CameraParameter), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(robot_calibration_msgs__msg__CameraParameter));
  bool success = robot_calibration_msgs__msg__CameraParameter__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
robot_calibration_msgs__msg__CameraParameter__destroy(robot_calibration_msgs__msg__CameraParameter * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    robot_calibration_msgs__msg__CameraParameter__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
robot_calibration_msgs__msg__CameraParameter__Sequence__init(robot_calibration_msgs__msg__CameraParameter__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__CameraParameter * data = NULL;

  if (size) {
    data = (robot_calibration_msgs__msg__CameraParameter *)allocator.zero_allocate(size, sizeof(robot_calibration_msgs__msg__CameraParameter), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = robot_calibration_msgs__msg__CameraParameter__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        robot_calibration_msgs__msg__CameraParameter__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
robot_calibration_msgs__msg__CameraParameter__Sequence__fini(robot_calibration_msgs__msg__CameraParameter__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      robot_calibration_msgs__msg__CameraParameter__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

robot_calibration_msgs__msg__CameraParameter__Sequence *
robot_calibration_msgs__msg__CameraParameter__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__CameraParameter__Sequence * array = (robot_calibration_msgs__msg__CameraParameter__Sequence *)allocator.allocate(sizeof(robot_calibration_msgs__msg__CameraParameter__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = robot_calibration_msgs__msg__CameraParameter__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
robot_calibration_msgs__msg__CameraParameter__Sequence__destroy(robot_calibration_msgs__msg__CameraParameter__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    robot_calibration_msgs__msg__CameraParameter__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
robot_calibration_msgs__msg__CameraParameter__Sequence__are_equal(const robot_calibration_msgs__msg__CameraParameter__Sequence * lhs, const robot_calibration_msgs__msg__CameraParameter__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!robot_calibration_msgs__msg__CameraParameter__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
robot_calibration_msgs__msg__CameraParameter__Sequence__copy(
  const robot_calibration_msgs__msg__CameraParameter__Sequence * input,
  robot_calibration_msgs__msg__CameraParameter__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(robot_calibration_msgs__msg__CameraParameter);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    robot_calibration_msgs__msg__CameraParameter * data =
      (robot_calibration_msgs__msg__CameraParameter *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!robot_calibration_msgs__msg__CameraParameter__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          robot_calibration_msgs__msg__CameraParameter__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!robot_calibration_msgs__msg__CameraParameter__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
