// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robot_calibration_msgs:msg/CaptureConfig.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__STRUCT_H_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'joint_states'
#include "sensor_msgs/msg/detail/joint_state__struct.h"
// Member 'features'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/CaptureConfig in the package robot_calibration_msgs.
/**
  * Pose the robot should be put in for this sample
 */
typedef struct robot_calibration_msgs__msg__CaptureConfig
{
  sensor_msgs__msg__JointState joint_states;
  /// Names of feature detectors to use for this sample
  rosidl_runtime_c__String__Sequence features;
} robot_calibration_msgs__msg__CaptureConfig;

// Struct for a sequence of robot_calibration_msgs__msg__CaptureConfig.
typedef struct robot_calibration_msgs__msg__CaptureConfig__Sequence
{
  robot_calibration_msgs__msg__CaptureConfig * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} robot_calibration_msgs__msg__CaptureConfig__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__STRUCT_H_
